Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 166)
@@ -453,4 +453,36 @@
   // get Original YUV data from picture
   m_ppcOrigYuv[uiDepth]->copyFromPicYuv( pcPic->getPicYuvOrg(), rpcBestCU->getAddr(), rpcBestCU->getZorderIdxInCU() );
+#if FORCE_REF_VSP
+  //Bool bWholeCUCanBeSynthesized = false;
+  //Bool bOneSubCUCanNotBeSynthesied = false;
+  Bool bSubCUCanBeSynthesized[4];
+  if( rpcBestCU->getSlice()->getViewId() )
+  {
+    Bool * pbSubCUCanBeSynthesized = bSubCUCanBeSynthesized;
+    pcPic->checkSynthesisAvailability(/*rpcBestCU, */rpcBestCU->getAddr(), rpcBestCU->getZorderIdxInCU(), uiDepth, pbSubCUCanBeSynthesized); //KUBA SYNTH
+    //Int  iSubCUCanNotBeSynthesized = 0;  // Dong: Compiling error, set but not used. DONG_CHECK
+    Int  iSubCUCanBeSynthesizedCnt = 0;
+    for(Int i = 0; i < 4; i++)
+    {
+      if (!bSubCUCanBeSynthesized[i])
+      {
+        //iSubCUCanNotBeSynthesized = i;
+      }
+      else
+      {
+        iSubCUCanBeSynthesizedCnt ++;
+      }
+    }
+    if(iSubCUCanBeSynthesizedCnt == 4)
+    {
+      //bWholeCUCanBeSynthesized = true;
+    }
+    //else if(iSubCUCanBeSynthesizedCnt == 3)
+    //{
+    //  bOneSubCUCanNotBeSynthesied = true;
+    //}
+    //bWholeCUCanBeSynthesized = true;
+  }
+#endif
 
   // variables for fast encoder decision
@@ -654,4 +686,19 @@
             doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
           }
+
+#if FORCE_REF_VSP==1
+#if VSP_TEXT_ONLY
+          if( !rpcBestCU->getSlice()->getSPS()->isDepth() )
+#endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
+            rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
+#endif
+#if HHI_INTERVIEW_SKIP
+            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec, false, true ); // VSP
+#else
+            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
+#endif
+            rpcTempCU->initEstData( uiDepth, iQP );
+#endif
         }
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -1581,10 +1628,26 @@
     {
       m_pcEntropyCoder->encodeSkipFlag( pcCU, uiAbsPartIdx );
+
+#if FORCE_REF_VSP==1
+      if( (pcCU->isSkipped( uiAbsPartIdx ) || pcCU->isVspMode( uiAbsPartIdx )) && pcCU->getSlice()->getViewId() != 0 )
+#if VSP_TEXT_ONLY
+      if( !pcCU->getSlice()->getSPS()->isDepth() )
+#endif
+      {
+        m_pcEntropyCoder->encodeVspFlag( pcCU, uiAbsPartIdx );
+      }
+#endif
     }
 
     if( pcCU->isSkipped( uiAbsPartIdx ) )
+#if FORCE_REF_VSP==1
+    if( !pcCU->isVspMode( uiAbsPartIdx ) )
+#endif
     {
       m_pcEntropyCoder->encodeMergeIndex( pcCU, uiAbsPartIdx, 0 );
       finishCU(pcCU,uiAbsPartIdx,uiDepth);
+#if DEBUGLOGOUT
+      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
       xRestoreDepthWidthHeight( pcCU );
       return;
@@ -1635,7 +1698,20 @@
   {
     m_pcEntropyCoder->encodeSkipFlag( pcCU, uiAbsPartIdx );
+
+#if FORCE_REF_VSP==1
+    if( (pcCU->isSkipped( uiAbsPartIdx ) || pcCU->isVspMode( uiAbsPartIdx )) && pcCU->getSlice()->getViewId() != 0 )
+#if VSP_TEXT_ONLY
+    if( !pcCU->getSlice()->getSPS()->isDepth() )
+#endif
+    {
+      m_pcEntropyCoder->encodeVspFlag( pcCU, uiAbsPartIdx );
+    }
+#endif
   }
   
   if( pcCU->isSkipped( uiAbsPartIdx ) )
+#if FORCE_REF_VSP==1
+  if( !pcCU->isVspMode( uiAbsPartIdx ) )
+#endif
   {
     m_pcEntropyCoder->encodeMergeIndex( pcCU, uiAbsPartIdx, 0 );
@@ -1644,6 +1720,21 @@
 #endif
     finishCU(pcCU,uiAbsPartIdx,uiDepth);
+#if DEBUGLOGOUT
+    m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
     return;
   }
+
+#if FORCE_REF_VSP==1
+  if( pcCU->isVspMode( uiAbsPartIdx ) )
+  {
+    finishCU(pcCU,uiAbsPartIdx,uiDepth);
+#if DEBUGLOGOUT
+    m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
+    return;
+  }
+#endif
+
 #if HHI_MPI
   if( pcCU->getTextureModeDepth( uiAbsPartIdx ) == -1 )
@@ -1662,4 +1753,7 @@
       // Encode slice finish
       finishCU(pcCU,uiAbsPartIdx,uiDepth);
+#if DEBUGLOGOUT
+      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
       return;
     }
@@ -1685,4 +1779,7 @@
   // --- write terminating bit ---
   finishCU(pcCU,uiAbsPartIdx,uiDepth);
+#if DEBUGLOGOUT
+  m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
 }
 
@@ -1873,5 +1970,9 @@
 #if AMP_MRG
 #if HHI_INTERVIEW_SKIP
-Void TEncCu::xCheckRDCostInter( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bSkipRes, Bool bUseMRG)
+Void TEncCu::xCheckRDCostInter( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bSkipRes, Bool bUseMRG
+#if FORCE_REF_VSP==1
+                               , Bool bForceRefVsp
+#endif
+                               )
 #else
 Void TEncCu::xCheckRDCostInter( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bUseMRG)
@@ -1910,4 +2011,9 @@
   rpcTempCU->setResPredFlagSubParts ( bResPrdFlag,  0, 0, uhDepth );
 #endif
+#if FORCE_REF_VSP==1
+  if( bForceRefVsp )
+    rpcTempCU->setPredModeSubParts  ( MODE_SYNTH, 0, uhDepth );
+  else
+#endif
   rpcTempCU->setPredModeSubParts  ( MODE_INTER, 0, uhDepth );
   
@@ -1925,5 +2031,9 @@
   #if HHI_INTERVIEW_SKIP
 #if LG_RESTRICTEDRESPRED_M24766
-  m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcResPredTmp[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], bSkipRes, bUseMRG  );
+  m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcResPredTmp[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], bSkipRes, bUseMRG
+#if FORCE_REF_VSP==1
+    , bForceRefVsp
+#endif
+    );
 #else
   m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], bSkipRes, bUseMRG  );
@@ -2494,8 +2604,32 @@
     for( UInt ui = 0; ui < rpcTempCU->getTotalNumPart(); ui++ )
     {
-      if( pcTextureCU->isIntra( rpcTempCU->getZorderIdxInCU() + ui ) )
+      if( pcTextureCU->isIntra( rpcTempCU->getZorderIdxInCU() + ui ) 
+#if FORCE_REF_VSP==1
+       || pcTextureCU->isVspMode( rpcTempCU->getZorderIdxInCU() + ui )
+#endif
+      )
       {
         return;
       }
+#if VSP_N
+#if !(!VSP_TEXT_ONLY && FORCE_REF_VSP==2)
+      else // inter
+      {
+        Int aiRefIdx[2] = {NOT_VALID, NOT_VALID};
+        for( Int iList = 0; iList < 2; iList++ )
+        {
+          aiRefIdx[iList] = pcTextureCU->getCUMvField( RefPicList(iList) )->getRefIdx( rpcTempCU->getZorderIdxInCU() + ui );
+          if( aiRefIdx[iList] >= 0 && pcTextureCU->getSlice()->getRefViewId( RefPicList(iList), aiRefIdx[iList] ) == NUM_VIEW_VSP )
+          {
+            return;
+          }
+        }
+        //if( aiRefIdx[0] == NOT_VALID && aiRefIdx[1] == NOT_VALID )
+        //{
+        //  return;
+        //}
+      }
+#endif
+#endif
     }
   }
@@ -2694,6 +2828,16 @@
   m_pcEntropyCoder->encodeSplitFlag( pcCU, 0, uhDepth, true );
   m_pcEntropyCoder->encodeSkipFlag( pcCU, 0, true );
+#if FORCE_REF_VSP==1
+  if( (pcCU->isSkipped( 0 ) || pcCU->isVspMode( 0 )) && pcCU->getSlice()->getViewId() != 0 )
+#if VSP_TEXT_ONLY
+  if( !pcCU->getSlice()->getSPS()->isDepth() )
+#endif
+    m_pcEntropyCoder->encodeVspFlag ( pcCU, 0, true );
+#endif
 
   if( pcCU->isSkipped( 0 ) )
+#if FORCE_REF_VSP==1
+  if( !pcCU->isVspMode( 0 ) )
+#endif
   {
     m_pcEntropyCoder->encodeMergeIndex( pcCU, 0, 0, true );
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.h	(revision 166)
@@ -46,4 +46,7 @@
 #include "TLibCommon/TComBitCounter.h"
 #include "TLibCommon/TComDataCU.h"
+#if DEBUGLOGOUT
+#include "TLibCommon/DebugLog.h"
+#endif
 
 #include "TEncEntropy.h"
@@ -113,4 +116,8 @@
 
 public:
+#if DEBUGLOGOUT
+  DebugLog                m_cDebug;
+#endif
+
   /// copy parameters from encoder class
   Void  init                ( TEncTop* pcEncTop );
@@ -148,5 +155,9 @@
 #if AMP_MRG
 #if HHI_INTERVIEW_SKIP
-  Void xCheckRDCostInter( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bFullyRendered, Bool bUseMRG = false  ) ;
+  Void xCheckRDCostInter( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bFullyRendered, Bool bUseMRG = false
+#if FORCE_REF_VSP==1
+    , Bool bForceRefVsp = false
+#endif
+    ) ;
 #else
   Void  xCheckRDCostInter   ( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bUseMRG = false  );
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 166)
@@ -169,4 +169,20 @@
 }
 
+
+#if FORCE_REF_VSP==1
+Void TEncEntropy::encodeVspFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
+{
+  if ( pcCU->getSlice()->isIntra() || pcCU->getSlice()->getViewId() == 0 )
+  {
+    return;
+  }
+  if( bRD )
+  {
+    uiAbsPartIdx = 0;
+  }
+  m_pcEntropyCoderIf->codeVspFlag( pcCU, uiAbsPartIdx );
+}
+#endif
+
 Void TEncEntropy::codeFiltCountBit(ALFParam* pAlfParam, Int64* ruiRate)
 {
@@ -1285,4 +1301,11 @@
     uiAbsPartIdx = 0;
   }
+
+#if FORCE_REF_VSP==1
+  if( pcCU->isVspMode( uiAbsPartIdx ) )
+  {
+    return;
+  }
+#endif
   
   PartSize eSize = pcCU->getPartitionSize( uiAbsPartIdx );
@@ -1345,6 +1368,14 @@
         {
           encodeRefFrmIdxPU ( pcCU, uiSubPartIdx, RefPicList( uiRefListIdx ) );
+#if VSP_MV_ZERO
+          Int iRefIdx = pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->getRefIdx(uiSubPartIdx);
+          if( !(pcCU->getSlice()->getViewId() && iRefIdx >= 0 && pcCU->getSlice()->getRefViewId( RefPicList( uiRefListIdx ), iRefIdx ) == NUM_VIEW_VSP) )
+          {
+#endif
           encodeMvdPU       ( pcCU, uiSubPartIdx, RefPicList( uiRefListIdx ) );
           encodeMVPIdxPU    ( pcCU, uiSubPartIdx, RefPicList( uiRefListIdx ) );
+#if VSP_MV_ZERO
+          }
+#endif
         }
       }
@@ -1632,4 +1663,7 @@
   {
     {
+#if FORCE_REF_VSP==1
+      if( !pcCU->isVspMode( uiAbsPartIdx ) )
+#endif
 #if HHI_MPI
       if( !(pcCU->getMergeFlag( uiAbsPartIdx ) && pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2Nx2N &&
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.h	(revision 166)
@@ -115,4 +115,7 @@
   
   virtual Void codeSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
+#if FORCE_REF_VSP==1
+  virtual Void codeVspFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
+#endif
   virtual Void codeMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
   virtual Void codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
@@ -251,4 +254,7 @@
   Void encodeSplitFlag         ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, Bool bRD = false );
   Void encodeSkipFlag          ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
+#if FORCE_REF_VSP==1
+  Void encodeVspFlag           ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
+#endif
   Void encodePUWise       ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
   Void encodeInterDirPU   ( TComDataCU* pcSubCU, UInt uiAbsPartIdx  );
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 166)
@@ -332,6 +332,19 @@
 #endif
 
+#if VSP_N
+      Int NumberOfVspRefs = ( ( pcPic->getViewId()==0
+#if VSP_TEXT_ONLY
+                                || m_pcEncTop->getIsDepth()
+#endif
+#if VSP_SLICE_HEADER
+                                || !m_pcEncTop->getUseVSP()
+#endif
+                              ) ? 0 : 1 );
+      pcSlice->setNumRefIdx( REF_PIC_LIST_0, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive + NumberOfVspRefs, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs() + NumberOfVspRefs) ) );
+      pcSlice->setNumRefIdx( REF_PIC_LIST_1, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive + NumberOfVspRefs, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs() + NumberOfVspRefs) ) );
+#else
       pcSlice->setNumRefIdx( REF_PIC_LIST_0, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs()) ) );
       pcSlice->setNumRefIdx( REF_PIC_LIST_1, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs()) ) );
+#endif
 
       TComRefPicListModification* refPicListModification = pcSlice->getRefPicListModification();
@@ -358,5 +371,19 @@
 
       std::vector<TComPic*> apcInterViewRefPics = tAppEncTop->getInterViewRefPics( m_pcEncTop->getViewId(), pcSlice->getPOC(), m_pcEncTop->getIsDepth(), pcSlice->getSPS() );
+#if VSP_N
+      Bool bUseVsp = (pcPic->getViewId()!=0);
+#if VSP_TEXT_ONLY
+      if( m_pcEncTop->getIsDepth() ) bUseVsp = false;
+#endif
+#if VSP_SLICE_HEADER
+      if( !m_pcEncTop->getUseVSP() ) bUseVsp = false;
+#endif
+      pcSlice->setRefPicListMvc( rcListPic, apcInterViewRefPics, bUseVsp ? m_pcEncTop->getVSPBuf() : NULL );
+#else
       pcSlice->setRefPicListMvc( rcListPic, apcInterViewRefPics );
+#endif
+#if VSP_SLICE_HEADER
+      pcSlice->setVspFlag( bUseVsp );
+#endif
 
       //  Slice info. refinement
@@ -1130,4 +1157,10 @@
           m_pcSbacCoder->load( &pcSbacCoders[0] );
 
+#if DEBUGLOGOUT
+        char fname[128];
+        sprintf(fname, "%sV%02d_%05d%s.csv", "Log", pcSlice->getViewId(), uiPOCCurr, pcSlice->getIsDepth() ? "depth":"text");
+        getSliceEncoder()->getCUEncoder()->m_cDebug.DebugLogFileOpen( fname );
+#endif
+
         pcSlice->setTileOffstForMultES( uiOneBitstreamPerSliceLength );
         if (!bEntropySlice)
@@ -1140,4 +1173,8 @@
           m_pcSliceEncoder->encodeSlice(pcPic, &nalu.m_Bitstream, pcSubstreamsOut); // nalu.m_Bitstream is only used for CAVLC tile position info.
         }
+
+#if DEBUGLOGOUT
+        getSliceEncoder()->getCUEncoder()->m_cDebug.DebugLogFileClose();
+#endif
 
         {
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 166)
@@ -718,5 +718,9 @@
 {
   // get context function is here
+#if FORCE_REF_VSP==1
+  UInt uiSymbol = (pcCU->isSkipped( uiAbsPartIdx ) || pcCU->isVspMode( uiAbsPartIdx )) ? 1 : 0;
+#else
   UInt uiSymbol = pcCU->isSkipped( uiAbsPartIdx ) ? 1 : 0;
+#endif
   UInt uiCtxSkip = pcCU->getCtxSkipFlag( uiAbsPartIdx ) ;
   m_pcBinIf->encodeBin( uiSymbol, m_cCUSkipFlagSCModel.get( 0, 0, uiCtxSkip ) );
@@ -730,4 +734,21 @@
 }
 
+#if FORCE_REF_VSP==1
+Void TEncSbac::codeVspFlag( TComDataCU* pcCU, UInt uiAbsPartIdx )
+{
+  // get context function is here
+  UInt uiSymbol = (UInt)pcCU->isVspMode( uiAbsPartIdx );
+  UInt uiCtxSkip = pcCU->getCtxSkipFlag( uiAbsPartIdx ) ;
+  m_pcBinIf->encodeBin( uiSymbol, m_cCUSkipFlagSCModel.get( 0, 0, uiCtxSkip ) );
+  DTRACE_CABAC_VL( g_nSymbolCounter++ );
+  DTRACE_CABAC_T( "\tVspFlag" );
+  DTRACE_CABAC_T( "\tuiCtxSkip: ");
+  DTRACE_CABAC_V( uiCtxSkip );
+  DTRACE_CABAC_T( "\tuiSymbol: ");
+  DTRACE_CABAC_V( uiSymbol );
+  DTRACE_CABAC_T( "\n");
+}
+#endif
+
 /** code merge flag
  * \param pcCU
@@ -764,5 +785,14 @@
   uiNumCand = pcCU->getSlice()->getMaxNumMergeCand();
 #if HHI_MPI
+#if VSP_TEXT_ONLY
+  TComDataCU* pcTextCU = pcCU->getSlice()->getSPS()->getUseMVI() ? pcCU->getSlice()->getTexturePic()->getCU( pcCU->getAddr() ) : NULL;
+  Int aiRefIdxVsp[2] = { pcTextCU ? pcTextCU->getCUMvField( RefPicList(0) )->getRefIdx( uiAbsPartIdx ) : -1,
+                         pcTextCU ? pcTextCU->getCUMvField( RefPicList(1) )->getRefIdx( uiAbsPartIdx ) : -1 };
+  const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
+    && !( aiRefIdxVsp[0] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(0), aiRefIdxVsp[0] ) == NUM_VIEW_VSP )
+    && !( aiRefIdxVsp[1] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(1), aiRefIdxVsp[1] ) == NUM_VIEW_VSP );
+#else
   const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
+#endif
   if( bMVIAvailable )
   {
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.h	(revision 166)
@@ -202,4 +202,7 @@
   Void codeAlfCtrlFlag   ( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void codeSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx );
+#if FORCE_REF_VSP==1
+  Void codeVspFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx );
+#endif
   Void codeMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx );
